Although a lot of people do this, I wanted to write a blog about how the following line of template code can help when solving a problem involving BFS on a grid or iterating over adjacent cells.

`const int dx[4] = {1,0,-1,0}, dy[4] = {0,1,0,-1};`

The way this works is quite simple. First, create a for loop like this:

`for(int i = 0; i < 4; i++){`

Then, using the x and y of the current cell, store the coordinates of the adjacent cell in newX and newY (or however you want to name your variables).

`newX = x + dx[i]; newY = y + dy[i];`

Now you can do whatever you need to do with newX and newY within the for loop (whether it's pushing to a queue for BFS or running some conditional). Make sure you check for out of bounds (which can be done with the function below).

`bool ok(int x, int y) { return x >= 0 && y >= 0 && x < n && y < m; }`

I know this is quite basic and a very common tactic, but I felt the need to write this to serve as an introduction to this technique for newer CPers. Hopefully this will save somebody lots of time. Feel free to share your techniques with grid problems in the comments.

Stay Safe! — Jellyman

NOTE: This is my first blog. Sorry if the formatting is garbage.

EDIT: Here is my solution to a problem I solved in a recent div 2 contest using this technique: 82826532

Is funny because this is well know but I did not see it anywhere except in someone else code when I was starting. Hope people see it now and don't waste time making a lot of if-else as I did.

Why and how does this work?

Sorry for the late reply. When i is 0, then newX becomes x + dx[0], which is x + 1. This means that when i is 0, newX and newY represent the cell to the right (y does not change because dy[0] is 0). Then, i becomes 1. When i is one, newX and newY represent the cell to the right, because newX = x + 0 and newY = y + 1. i = 2 and i = 3 checks left and bottom respectively. Hope this makes sense.

late reply? It's been less than two hours!

DAMN! This is good

For problems involving diagonal transitions as well (like, a king's move in chess), you can do the same thing:

So far, this is pretty obvious, but the cool part (at least, I find it kind of clever) is that in the situation with only 4 transitions, you can use the exact same code, and just loop over the first 4 elements.

Thanks for pointing this out!

Can you please explain how did you choose array dx and dy?

Write down the coordinates for the points in a 3x3 square around the origin, now put the x's and the y's in two separate arrays. I put the horizontal/vertical points before the diagonal ones, so that we can do the trick I mentioned.

or you can also doTaken from my quora answer

one suggestion: provide a link to any such grid problem and show the full code to demonstrate this method.

I have some problems so everyone can practice:

https://codeforces.com/contest/1365/problem/D

https://codeforces.com/contest/598/problem/D

https://codeforces.com/contest/510/problem/B

Thanks for the feedback. I'll look for one to add. Love your vids btw :)

With C++17 (or just GCC >= 8) it can be done in simpler way without indexing:

Example

Superb!!

I saw Errichto do it in floodfill problem, I also started doing it since then, pretty cool.

Surely your method is clean and nice. There is another way to navigate:

`0 : Up`

`1 : Left`

`2 : Down`

`3 : Right`

I learned this in one of icecuber's solutions and I think it's pretty cool!

Really cool ! <3

For people who uses vector instead of global C style array, there may be some problems that could get TLE if not used carefully: https://codeforces.com/blog/entry/77847

Also, you can use this to check if you are within the borders:

Is this a defined behaviour?

I'm pretty sure it is.